- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnPfxGeometry Class Reference

# OpenMayaFX - API module for effects | FunctionSet classes

Search for all occurrences

## Detailed Description

PfxGeometry node function set.

This is the function set for paint effects objects.

PfxGeometry is the parent class for the stroke and pfxHair node. The output geometry for pfxHair and stroke nodes may be accessed through this class.

Examples:

  pfxInfoCmd.cpp.

`#include <MFnPfxGeometry.h>`

Inheritance diagram for MFnPfxGeometry:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnPfxGeometry ()
| Destructor.
| MFnPfxGeometry ()
| Default constructor.
| MFnPfxGeometry (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
| MFnPfxGeometry (const MDagPath &object, MStatus *ret=NULL)
| Constructor.
MStatus | getLineData (MRenderLineArray &mainLines, MRenderLineArray &leafLines, MRenderLineArray &flowerLines, bool doLines, bool doTwist, bool doWidth, bool doFlatness, bool doParameter, bool doColor, bool doIncandescence, bool doTransparency, bool worldSpace)
| Get line data for the current output pfx tubes.
MStatus | getBoundingBox (double *min, double *max)
| Gets the bounding box of the specified geometry.
| MFnPfxGeometry (const MObject &object, MStatus *ret=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

~MFnPfxGeometry | ( |  | ) | `[virtual]`

Destructor.

Class Destructor.

MFnPfxGeometry | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnPfxGeometry | ( | const MDagPath & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given constant MDagPath object.

Parameters:

  [in] | object | The const MDagPath to attach the function set to
  [out] | ReturnStatus | The return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnPfxGeometry | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kPfxGeometry.

Reimplemented from MFnDagNode.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnPfxGeometry".

Reimplemented from MFnDagNode.

MStatus getLineData | ( | MRenderLineArray & | mainLines,
|  | MRenderLineArray & | leafLines,
|  | MRenderLineArray & | flowerLines,
|  | bool | doLines,
|  | bool | doTwist,
|  | bool | doWidth,
|  | bool | doFlatness,
|  | bool | doParameter,
|  | bool | doColor,
|  | bool | doIncandescence,
|  | bool | doTransparency,
|  | bool | worldSpace
| ) |  |

Search for all occurrences

Get line data for the current output pfx tubes.

The passed in arrays will be filled with pointers to MrenderLine classes. If there are no leaves or flowers then the passed in leafLine and flowerLine arrays will be left empty. Arrays are generated for only the specified attributes. This routine creates the memory for the arrays that it computes. This memory can only be released using the deleteArray method on the MRenderLineArray class. DeleteArray should be called for the mainLine, leafLine, and flowerLine variables when done. These variables wrap the returned data and allow access but the MRenderLineArray destructer does not delete this wrapped memory, so one must use MRenderLineArray::deleteArray(). The MRenderLine, MVectorArray and MDoubleArrays returned from MRenderLineArray will point to deleted memory after calling deleteArray, so be careful to only call deleteArray when finished using the line data(or copy the arrays first).

Parameters:

  [out] | mainLines | primary MRenderLineArray
  [out] | leafLines | leaf MRenderLineArray
  [out] | flowerLines | flower MRenderLineArray
  [in] | doLines | create line(vertex) arrays
  [in] | doTwist | create twist arrays
  [in] | doWidth | create width arrays
  [in] | doFlatness | create flatness arrays
  [in] | doParameter | create parameter arrays
  [in] | doColor | create color arrays
  [in] | doIncandescence | create incandescence arrays
  [in] | doTransparency | create transparency arrays
  [in] | worldSpace | compute lines in worldspace, instead of the stroke objectspace

Returns:
  Status code

Status Codes:
  - MS::kSuccess The method was successful.
  - MS::kFailure An object error has occurred.

MStatus getBoundingBox | ( | double * | min,
|  | double * | max
| ) |  |

Search for all occurrences

Gets the bounding box of the specified geometry.

The passed in double arrays will be filled with minimum and maximum coordinates of the geometry.

Parameters:

  [out] | min | minimum coordinates
  [out] | max | maximum coordinates

Returns:
  Status code

Status Codes:
  - MS::kSuccess The method was successful.
  - MS::kFailure An object error has occurred.

MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry
MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry MFnPfxGeometry